Index: serefpolicy-contrib-20140730/sblim.if
===================================================================
--- serefpolicy-contrib-20140730.orig/sblim.if
+++ serefpolicy-contrib-20140730/sblim.if
@@ -1,8 +1,36 @@
-## <summary>Standards Based Linux Instrumentation for Manageability.</summary>
+## <summary> Standards Based Linux Instrumentation for Manageability. </summary>
+
+######################################
+## <summary>
+##  Creates types and rules for a basic
+##  sblim daemon domain.
+## </summary>
+## <param name="prefix">
+##  <summary>
+##  Prefix for the domain.
+##  </summary>
+## </param>
+#
+template(`sblim_domain_template',`
+    gen_require(`
+        attribute sblim_domain;
+    ')
+
+    type sblim_$1_t, sblim_domain;
+    type sblim_$1_exec_t;
+    init_daemon_domain(sblim_$1_t, sblim_$1_exec_t)
+
+	kernel_read_system_state(sblim_$1_t)
+
+	corenet_all_recvfrom_unlabeled(sblim_$1_t)
+	corenet_all_recvfrom_netlabel(sblim_$1_t)
+
+	logging_send_syslog_msg(sblim_$1_t)
+')
 
 ########################################
 ## <summary>
-##	Execute gatherd in the gatherd domain.
+##	Transition to gatherd.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -21,7 +49,7 @@ interface(`sblim_domtrans_gatherd',`
 
 ########################################
 ## <summary>
-##	Read gatherd pid files.
+##	Read gatherd PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -40,34 +68,129 @@ interface(`sblim_read_pid_files',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an sblim environment.
+##	Transition to sblim named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`sblim_filetrans_named_content',`
+	gen_require(`
+		type sblim_var_run_t;
+	')
+
+	files_pid_filetrans($1, sblim_var_run_t, dir, "gather")
+')
+
+########################################
+## <summary>
+##	Connect to sblim_sfcb over a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`sblim_stream_connect_sfcbd',`
+	gen_require(`
+		type sblim_sfcb_t, sblim_var_lib_t;
+        type sblim_tmp_t;
+	')
+
+	files_search_pids($1)
+	stream_connect_pattern($1, sblim_var_lib_t, sblim_var_lib_t, sblim_sfcb_t)
+	stream_connect_pattern($1, sblim_var_lib_t, sblim_tmp_t, sblim_tmp_t)
+')
+
+#######################################
+## <summary>
+##  Getattr on sblim executable.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`sblim_getattr_exec_sfcbd',`
+    gen_require(`
+        type sblim_sfcbd_exec_t;
+    ')
+
+	allow $1 sblim_sfcbd_exec_t:file getattr;
+')
+
+
+########################################
+## <summary>
+##	Connect to sblim_sfcb over a unix stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`sblim_stream_connect_sfcb',`
+	gen_require(`
+		type sblim_sfcb_t, sblim_var_lib_t;
+	')
+
+	files_search_pids($1)
+	stream_connect_pattern($1, sblim_var_lib_t, sblim_var_lib_t, sblim_sfcb_t)
+')
+
+#######################################
+## <summary>
+##	Allow read and write access to sblim semaphores.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`sblim_rw_semaphores_sfcbd',`
+	gen_require(`
+		type sblim_sfcbd_t;
+	')
+
+	allow $1 sblim_sfcbd_t:sem rw_sem_perms;
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an gatherd environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`sblim_admin',`
 	gen_require(`
-		attribute sblim_domain;
-		type sblim_initrc_exec_t, sblim_var_run_t;
+		type sblim_gatherd_t;
+		type sblim_reposd_t;
+		type sblim_var_run_t;
 	')
 
-	allow $1 sblim_domain:process { ptrace signal_perms };
-	ps_process_pattern($1, sblim_domain)
+	allow $1 sblim_gatherd_t:process signal_perms;
+	ps_process_pattern($1, sblim_gatherd_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 sblim_gatherd_t:process ptrace;
+		allow $1 sblim_reposd_t:process ptrace;
+	')
 
-	init_labeled_script_domtrans($1, sblim_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 sblim_initrc_exec_t system_r;
-	allow $2 system_r;
+	allow $1 sblim_reposd_t:process signal_perms;
+	ps_process_pattern($1, sblim_reposd_t)
 
 	files_search_pids($1)
 	admin_pattern($1, sblim_var_run_t)
Index: serefpolicy-contrib-20140730/sblim.te
===================================================================
--- serefpolicy-contrib-20140730.orig/sblim.te
+++ serefpolicy-contrib-20140730/sblim.te
@@ -7,13 +7,11 @@ policy_module(sblim, 1.1.0)
 
 attribute sblim_domain;
 
-type sblim_gatherd_t, sblim_domain;
-type sblim_gatherd_exec_t;
-init_daemon_domain(sblim_gatherd_t, sblim_gatherd_exec_t)
-
-type sblim_reposd_t, sblim_domain;
-type sblim_reposd_exec_t;
-init_daemon_domain(sblim_reposd_t, sblim_reposd_exec_t)
+sblim_domain_template(gatherd)
+
+sblim_domain_template(reposd)
+
+sblim_domain_template(sfcbd)
 
 type sblim_initrc_exec_t;
 init_script_file(sblim_initrc_exec_t)
@@ -21,6 +19,15 @@ init_script_file(sblim_initrc_exec_t)
 type sblim_var_run_t;
 files_pid_file(sblim_var_run_t)
 
+type sblim_var_lib_t;
+files_type(sblim_var_lib_t)
+
+type sblim_tmp_t;
+files_tmp_file(sblim_tmp_t)
+
+type sblim_sfcb_tmpfs_t;
+files_tmpfs_file(sblim_sfcb_tmpfs_t)
+
 ######################################
 #
 # Common sblim domain local policy
@@ -31,32 +38,38 @@ allow sblim_domain self:tcp_socket creat
 manage_dirs_pattern(sblim_domain, sblim_var_run_t, sblim_var_run_t)
 manage_files_pattern(sblim_domain, sblim_var_run_t, sblim_var_run_t)
 manage_sock_files_pattern(sblim_domain, sblim_var_run_t, sblim_var_run_t)
+files_pid_filetrans(sblim_domain, sblim_var_run_t,dir,"gather")
+
+manage_dirs_pattern(sblim_domain, sblim_var_lib_t, sblim_var_lib_t)
+manage_files_pattern(sblim_domain, sblim_var_lib_t, sblim_var_lib_t)
+manage_lnk_files_pattern(sblim_domain, sblim_var_lib_t, sblim_var_lib_t)
+files_var_lib_filetrans(sblim_domain, sblim_var_lib_t, { dir file lnk_file })
+
+manage_dirs_pattern(sblim_domain, sblim_tmp_t, sblim_tmp_t)
+manage_files_pattern(sblim_domain, sblim_tmp_t, sblim_tmp_t)
+manage_sock_files_pattern(sblim_domain, sblim_tmp_t, sblim_tmp_t)
+files_tmp_filetrans(sblim_domain, sblim_tmp_t, { dir file sock_file})
 
 kernel_read_network_state(sblim_domain)
-kernel_read_system_state(sblim_domain)
 
-corenet_all_recvfrom_unlabeled(sblim_domain)
-corenet_all_recvfrom_netlabel(sblim_domain)
 corenet_tcp_sendrecv_generic_if(sblim_domain)
 corenet_tcp_sendrecv_generic_node(sblim_domain)
 
 corenet_tcp_sendrecv_repository_port(sblim_domain)
 
 dev_read_sysfs(sblim_domain)
+dev_read_rand(sblim_domain)
+dev_read_urand(sblim_domain)
 
-logging_send_syslog_msg(sblim_domain)
-
-files_read_etc_files(sblim_domain)
-
-miscfiles_read_localization(sblim_domain)
+auth_read_passwd(sblim_domain)
 
 ########################################
 #
 # Gatherd local policy
 #
 
-allow sblim_gatherd_t self:capability dac_override;
-allow sblim_gatherd_t self:process signal;
+allow sblim_gatherd_t self:capability { dac_override sys_nice };
+allow sblim_gatherd_t self:process { setsched signal };
 allow sblim_gatherd_t self:fifo_file rw_fifo_file_perms;
 allow sblim_gatherd_t self:unix_stream_socket { accept listen };
 
@@ -84,6 +97,8 @@ storage_raw_read_removable_device(sblim_
 
 init_read_utmp(sblim_gatherd_t)
 
+logging_send_syslog_msg(sblim_gatherd_t)
+
 sysnet_dns_name_resolve(sblim_gatherd_t)
 
 term_getattr_pty_fs(sblim_gatherd_t)
@@ -103,8 +118,9 @@ optional_policy(`
 ')
 
 optional_policy(`
-	virt_getattr_virtd_exec_files(sblim_gatherd_t)
+	virt_read_config(sblim_gatherd_t)
 	virt_stream_connect(sblim_gatherd_t)
+	virt_getattr_exec(sblim_gatherd_t)
 ')
 
 optional_policy(`
@@ -117,6 +133,43 @@ optional_policy(`
 # Reposd local policy
 #
 
+corenet_tcp_bind_generic_node(sblim_reposd_t)
+
 corenet_sendrecv_repository_server_packets(sblim_reposd_t)
 corenet_tcp_bind_repository_port(sblim_reposd_t)
-corenet_tcp_bind_generic_node(sblim_domain)
+
+logging_send_syslog_msg(sblim_reposd_t)
+
+#######################################
+#
+# Sfcbd local policy
+#
+
+allow sblim_sfcbd_t self:capability { sys_ptrace setgid };
+allow sblim_sfcbd_t self:process signal;
+allow sblim_sfcbd_t self:unix_stream_socket connectto;
+
+manage_dirs_pattern(sblim_sfcbd_t, sblim_sfcb_tmpfs_t, sblim_sfcb_tmpfs_t)
+manage_files_pattern(sblim_sfcbd_t, sblim_sfcb_tmpfs_t, sblim_sfcb_tmpfs_t)
+fs_tmpfs_filetrans(sblim_sfcbd_t, sblim_sfcb_tmpfs_t, { dir file })
+
+auth_use_nsswitch(sblim_sfcbd_t)
+
+corenet_tcp_bind_pegasus_http_port(sblim_sfcbd_t)
+corenet_tcp_connect_pegasus_http_port(sblim_sfcbd_t)
+corenet_tcp_bind_pegasus_https_port(sblim_sfcbd_t)
+corenet_tcp_connect_pegasus_https_port(sblim_sfcbd_t)
+
+corecmd_exec_shell(sblim_sfcbd_t)
+corecmd_exec_bin(sblim_sfcbd_t)
+
+dev_read_rand(sblim_sfcbd_t)
+dev_read_urand(sblim_sfcbd_t)
+
+domain_read_all_domains_state(sblim_sfcbd_t)
+domain_use_interactive_fds(sblim_sfcbd_t)
+
+optional_policy(`
+    rpm_exec(sblim_sfcbd_t)
+    rpm_dontaudit_manage_db(sblim_sfcbd_t)
+')
Index: serefpolicy-contrib-20140730/screen.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/screen.fc
+++ serefpolicy-contrib-20140730/screen.fc
@@ -2,8 +2,10 @@ HOME_DIR/\.screen(/.*)?	gen_context(syst
 HOME_DIR/\.screenrc	--	gen_context(system_u:object_r:screen_home_t,s0)
 HOME_DIR/\.tmux\.conf	--	gen_context(system_u:object_r:screen_home_t,s0)
 
-/usr/bin/screen	--	gen_context(system_u:object_r:screen_exec_t,s0)
-/usr/bin/tmux	--	gen_context(system_u:object_r:screen_exec_t,s0)
+/root/\.screen(/.*)?			gen_context(system_u:object_r:screen_home_t,s0)
 
-/var/run/screen(/.*)?	gen_context(system_u:object_r:screen_var_run_t,s0)
-/var/run/tmux(/.*)?	gen_context(system_u:object_r:screen_var_run_t,s0)
+/usr/bin/screen			--	gen_context(system_u:object_r:screen_exec_t,s0)
+/usr/bin/tmux			--	gen_context(system_u:object_r:screen_exec_t,s0)
+
+/var/run/screen(/.*)?			gen_context(system_u:object_r:screen_var_run_t,s0)
+/var/run/tmux(/.*)?			gen_context(system_u:object_r:screen_var_run_t,s0)
Index: serefpolicy-contrib-20140730/screen.if
===================================================================
--- serefpolicy-contrib-20140730.orig/screen.if
+++ serefpolicy-contrib-20140730/screen.if
@@ -1,4 +1,4 @@
-## <summary>GNU terminal multiplexer.</summary>
+## <summary>GNU terminal multiplexer</summary>
 
 #######################################
 ## <summary>
@@ -23,10 +23,9 @@
 #
 template(`screen_role_template',`
 	gen_require(`
-		attribute screen_domain;
-		attribute_role screen_roles;
 		type screen_exec_t, screen_tmp_t;
 		type screen_home_t, screen_var_run_t;
+		attribute screen_domain;
 	')
 
 	########################################
@@ -35,52 +34,52 @@ template(`screen_role_template',`
 	#
 
 	type $1_screen_t, screen_domain;
-	userdom_user_application_domain($1_screen_t, screen_exec_t)
+	application_domain($1_screen_t, screen_exec_t)
 	domain_interactive_fd($1_screen_t)
-	role screen_roles types $1_screen_t;
-
-	roleattribute $2 screen_roles;
+	ubac_constrained($1_screen_t)
+	role $2 types $1_screen_t;
 
-	########################################
-	#
-	# Local policy
-	#
+	tunable_policy(`deny_ptrace',`',`
+		allow $3 $1_screen_t:process ptrace;
+	')
 
-	dontaudit $1_screen_t self:capability sys_tty_config;
+	userdom_home_reader($1_screen_t)
 
 	domtrans_pattern($3, screen_exec_t, $1_screen_t)
-
-	ps_process_pattern($3, $1_screen_t)
-	allow $3 $1_screen_t:process { ptrace signal_perms };
-
+	allow $3 $1_screen_t:process { signal sigchld };
 	dontaudit $3 $1_screen_t:unix_stream_socket { read write };
+	allow $1_screen_t $3:unix_stream_socket { connectto };
 	allow $1_screen_t $3:process signal;
+	ps_process_pattern($1_screen_t, $3)
 
-	allow $3 screen_tmp_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 screen_tmp_t:file { manage_file_perms relabel_file_perms };
-	allow $3 screen_tmp_t:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-
-	allow $3 screen_home_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 screen_home_t:file { manage_file_perms relabel_file_perms };
-	allow $3 screen_home_t:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-	allow $3 screen_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
+	manage_fifo_files_pattern($3, screen_home_t, screen_home_t)
+	manage_dirs_pattern($3, screen_home_t, screen_home_t)
+	manage_files_pattern($3, screen_home_t, screen_home_t)
+	manage_lnk_files_pattern($3, screen_home_t, screen_home_t)
+	relabel_dirs_pattern($3, screen_home_t, screen_home_t)
+	relabel_files_pattern($3, screen_home_t, screen_home_t)
+	relabel_lnk_files_pattern($3, screen_home_t, screen_home_t)
 
 	userdom_user_home_dir_filetrans($3, screen_home_t, dir, ".screen")
 	userdom_user_home_dir_filetrans($3, screen_home_t, file, ".screenrc")
 	userdom_user_home_dir_filetrans($3, screen_home_t, file, ".tmux.conf")
 
 	manage_dirs_pattern($3, screen_var_run_t, screen_var_run_t)
-	manage_files_pattern($3, screen_var_run_t, screen_var_run_t)
-	manage_lnk_files_pattern($3, screen_var_run_t, screen_var_run_t)
 	manage_fifo_files_pattern($3, screen_var_run_t, screen_var_run_t)
 
-	corecmd_bin_domtrans($1_screen_t, $3)
+	kernel_read_system_state($1_screen_t)
+
+	# Revert to the user domain when a shell is executed.
 	corecmd_shell_domtrans($1_screen_t, $3)
+	corecmd_bin_domtrans($1_screen_t, $3)
 
 	auth_domtrans_chk_passwd($1_screen_t)
 	auth_use_nsswitch($1_screen_t)
 
+	logging_send_syslog_msg($1_screen_t)
+
 	userdom_user_home_domtrans($1_screen_t, $3)
+	userdom_manage_tmp_role($2, $1_screen_t)
 
 	tunable_policy(`use_samba_home_dirs',`
 		fs_cifs_domtrans($1_screen_t, $3)
@@ -90,3 +89,41 @@ template(`screen_role_template',`
 		fs_nfs_domtrans($1_screen_t, $3)
 	')
 ')
+
+#######################################
+## <summary>
+##      Execute the rssh program
+##      in the caller domain.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`screen_exec',`
+        gen_require(`
+                type screen_exec_t;
+        ')
+
+        can_exec($1, screen_exec_t)
+')
+
+########################################
+## <summary>
+##	Send a SIGCHLD signal to the screen domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`screen_sigchld',`
+	gen_require(`
+		attribute screen_domain;
+	')
+
+	allow $1 screen_domain:process sigchld;
+')
+
Index: serefpolicy-contrib-20140730/screen.te
===================================================================
--- serefpolicy-contrib-20140730.orig/screen.te
+++ serefpolicy-contrib-20140730/screen.te
@@ -1,13 +1,11 @@
-policy_module(screen, 2.7.0)
+policy_module(screen, 2.6.0)
 
 ########################################
 #
 # Declarations
 #
 
-attribute screen_domain;
-
-attribute_role screen_roles;
+attribute  screen_domain;
 
 type screen_exec_t;
 application_executable_file(screen_exec_t)
@@ -17,11 +15,6 @@ typealias screen_home_t alias { user_scr
 typealias screen_home_t alias { auditadm_screen_home_t secadm_screen_home_t };
 userdom_user_home_content(screen_home_t)
 
-type screen_tmp_t;
-typealias screen_tmp_t alias { user_screen_tmp_t staff_screen_tmp_t sysadm_screen_tmp_t };
-typealias screen_tmp_t alias { auditadm_screen_tmp_t secadm_screen_tmp_t };
-userdom_user_tmp_file(screen_tmp_t)
-
 type screen_var_run_t;
 typealias screen_var_run_t alias { user_screen_var_run_t staff_screen_var_run_t sysadm_screen_var_run_t };
 typealias screen_var_run_t alias { auditadm_screen_var_run_t secadm_screen_var_run_t screen_dir_t };
@@ -30,34 +23,35 @@ ubac_constrained(screen_var_run_t)
 
 ########################################
 #
-# Common screen domain local policy
+# Local policy
 #
 
-allow screen_domain self:capability { setuid setgid fsetid };
+allow screen_domain self:capability { fsetid setgid setuid sys_tty_config };
+dontaudit screen_domain self:capability dac_override;
 allow screen_domain self:process signal_perms;
-allow screen_domain self:fd use;
 allow screen_domain self:fifo_file rw_fifo_file_perms;
-allow screen_domain self:tcp_socket { accept listen };
-allow screen_domain self:unix_stream_socket { accept connectto listen };
-
-manage_dirs_pattern(screen_domain, screen_tmp_t, screen_tmp_t)
-manage_files_pattern(screen_domain, screen_tmp_t, screen_tmp_t)
-manage_fifo_files_pattern(screen_domain, screen_tmp_t, screen_tmp_t)
-files_tmp_filetrans(screen_domain, screen_tmp_t, { file dir })
-filetrans_pattern(screen_domain, screen_tmp_t, screen_var_run_t, sock_file)
+allow screen_domain self:tcp_socket create_stream_socket_perms;
+allow screen_domain self:udp_socket create_socket_perms;
+# Internal screen networking
+allow screen_domain self:fd use;
+allow screen_domain self:unix_stream_socket { create_socket_perms connectto };
+allow screen_domain self:unix_dgram_socket create_socket_perms;
 
+# Create fifo
 manage_fifo_files_pattern(screen_domain, screen_var_run_t, screen_var_run_t)
 manage_dirs_pattern(screen_domain, screen_var_run_t, screen_var_run_t)
 manage_sock_files_pattern(screen_domain, screen_var_run_t, screen_var_run_t)
 files_pid_filetrans(screen_domain, screen_var_run_t, dir)
 
+allow screen_domain screen_home_t:dir list_dir_perms;
 manage_dirs_pattern(screen_domain, screen_home_t, screen_home_t)
-read_files_pattern(screen_domain, screen_home_t, screen_home_t)
 manage_fifo_files_pattern(screen_domain, screen_home_t, screen_home_t)
+manage_sock_files_pattern(screen_domain, screen_home_t, screen_home_t)
+userdom_user_home_dir_filetrans(screen_domain, screen_home_t, dir)
+userdom_admin_home_dir_filetrans(screen_domain, screen_home_t, dir)
+read_files_pattern(screen_domain, screen_home_t, screen_home_t)
 read_lnk_files_pattern(screen_domain, screen_home_t, screen_home_t)
-userdom_user_home_dir_filetrans(screen_domain, screen_home_t, dir, ".screen")
 
-kernel_read_system_state(screen_domain)
 kernel_read_kernel_sysctls(screen_domain)
 
 corecmd_list_bin(screen_domain)
@@ -66,55 +60,39 @@ corecmd_read_bin_symlinks(screen_domain)
 corecmd_read_bin_pipes(screen_domain)
 corecmd_read_bin_sockets(screen_domain)
 
-corenet_all_recvfrom_unlabeled(screen_domain)
-corenet_all_recvfrom_netlabel(screen_domain)
 corenet_tcp_sendrecv_generic_if(screen_domain)
+corenet_udp_sendrecv_generic_if(screen_domain)
 corenet_tcp_sendrecv_generic_node(screen_domain)
+corenet_udp_sendrecv_generic_node(screen_domain)
 corenet_tcp_sendrecv_all_ports(screen_domain)
-
-corenet_sendrecv_all_client_packets(screen_domain)
+corenet_udp_sendrecv_all_ports(screen_domain)
 corenet_tcp_connect_all_ports(screen_domain)
 
 dev_dontaudit_getattr_all_chr_files(screen_domain)
 dev_dontaudit_getattr_all_blk_files(screen_domain)
+# for SSP
 dev_read_urand(screen_domain)
 
-domain_use_interactive_fds(screen_domain)
 domain_sigchld_interactive_fds(screen_domain)
+domain_use_interactive_fds(screen_domain)
 domain_read_all_domains_state(screen_domain)
 
+files_search_tmp(screen_domain)
+files_search_home(screen_domain)
 files_list_home(screen_domain)
-files_read_usr_files(screen_domain)
 
 fs_search_auto_mountpoints(screen_domain)
-fs_getattr_all_fs(screen_domain)
+fs_getattr_xattr_fs(screen_domain)
 
 auth_dontaudit_read_shadow(screen_domain)
 auth_dontaudit_exec_utempter(screen_domain)
 
+# Write to utmp.
 init_rw_utmp(screen_domain)
 
-logging_send_syslog_msg(screen_domain)
-
-miscfiles_read_localization(screen_domain)
-
 seutil_read_config(screen_domain)
 
 userdom_use_user_terminals(screen_domain)
 userdom_create_user_pty(screen_domain)
 userdom_setattr_user_ptys(screen_domain)
 userdom_setattr_user_ttys(screen_domain)
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_manage_cifs_dirs(screen_domain)
-	fs_read_cifs_files(screen_domain)
-	fs_manage_cifs_named_pipes(screen_domain)
-	fs_read_cifs_symlinks(screen_domain)
-')
-
-tunable_policy(`use_nfs_home_dirs',`
-	fs_manage_nfs_dirs(screen_domain)
-	fs_read_nfs_files(screen_domain)
-	fs_manage_nfs_named_pipes(screen_domain)
-	fs_read_nfs_symlinks(screen_domain)
-')
Index: serefpolicy-contrib-20140730/sectoolm.if
===================================================================
--- serefpolicy-contrib-20140730.orig/sectoolm.if
+++ serefpolicy-contrib-20140730/sectoolm.if
@@ -1,24 +1,2 @@
-## <summary>Sectool security audit tool.</summary>
+## <summary>Sectool security audit tool</summary>
 
-########################################
-## <summary>
-##	Role access for sectoolm.
-## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-interface(`sectoolm_role',`
-	gen_require(`
-		type sectoolm_t;
-	')
-
-	allow sectoolm_t $2:unix_dgram_socket sendto;
-')
Index: serefpolicy-contrib-20140730/sectoolm.te
===================================================================
--- serefpolicy-contrib-20140730.orig/sectoolm.te
+++ serefpolicy-contrib-20140730/sectoolm.te
@@ -7,7 +7,7 @@ policy_module(sectoolm, 1.1.0)
 
 type sectoolm_t;
 type sectoolm_exec_t;
-init_system_domain(sectoolm_t, sectoolm_exec_t)
+init_daemon_domain(sectoolm_t, sectoolm_exec_t)
 
 type sectool_var_lib_t;
 files_type(sectool_var_lib_t)
@@ -20,14 +20,14 @@ files_tmp_file(sectool_tmp_t)
 
 ########################################
 #
-# Local policy
+# sectool local policy
 #
 
-allow sectoolm_t self:capability { dac_override net_admin sys_nice };
+allow sectoolm_t self:capability { dac_override net_admin sys_nice sys_ptrace };
 allow sectoolm_t self:process { getcap getsched	signull setsched };
 dontaudit sectoolm_t self:process { execstack execmem };
 allow sectoolm_t self:fifo_file rw_fifo_file_perms;
-allow sectoolm_t self:unix_dgram_socket sendto;
+allow sectoolm_t self:unix_dgram_socket { create_socket_perms sendto };
 
 manage_dirs_pattern(sectoolm_t, sectool_tmp_t, sectool_tmp_t)
 manage_files_pattern(sectoolm_t, sectool_tmp_t, sectool_tmp_t)
@@ -37,7 +37,7 @@ manage_files_pattern(sectoolm_t, sectool
 manage_dirs_pattern(sectoolm_t, sectool_var_lib_t, sectool_var_lib_t)
 files_var_lib_filetrans(sectoolm_t, sectool_var_lib_t, { file dir })
 
-allow sectoolm_t sectool_var_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+manage_files_pattern(sectoolm_t, sectool_var_log_t, sectool_var_log_t)
 logging_log_filetrans(sectoolm_t, sectool_var_log_t, file)
 
 kernel_read_net_sysctls(sectoolm_t)
@@ -65,6 +65,7 @@ fs_list_noxattr_fs(sectoolm_t)
 
 selinux_validate_context(sectoolm_t)
 
+# tcp_wrappers test
 application_exec_all(sectoolm_t)
 
 auth_use_nsswitch(sectoolm_t)
@@ -73,30 +74,36 @@ libs_exec_ld_so(sectoolm_t)
 
 logging_send_syslog_msg(sectoolm_t)
 
+# tests related to network
 sysnet_domtrans_ifconfig(sectoolm_t)
 
-userdom_write_user_tmp_sockets(sectoolm_t)
+userdom_manage_user_tmp_sockets(sectoolm_t)
+userdom_dgram_send(sectoolm_t)
 
 optional_policy(`
-	mount_exec(sectoolm_t)
+	dbus_system_domain(sectoolm_t, sectoolm_exec_t)
 ')
 
 optional_policy(`
-	dbus_system_domain(sectoolm_t, sectoolm_exec_t)
+	# tests related to network
+	hostname_exec(sectoolm_t)
+')
 
-	optional_policy(`
-		policykit_dbus_chat(sectoolm_t)
-	')
+optional_policy(`
+	# tests related to network
+	iptables_domtrans(sectoolm_t)
 ')
 
 optional_policy(`
-	hostname_exec(sectoolm_t)
+	mount_exec(sectoolm_t)
 ')
 
 optional_policy(`
-	iptables_domtrans(sectoolm_t)
+	policykit_dbus_chat(sectoolm_t)
 ')
 
+# suid test using
+# rpm -Vf option
 optional_policy(`
 	prelink_domtrans(sectoolm_t)
 ')
Index: serefpolicy-contrib-20140730/sendmail.if
===================================================================
--- serefpolicy-contrib-20140730.orig/sendmail.if
+++ serefpolicy-contrib-20140730/sendmail.if
@@ -1,4 +1,4 @@
-## <summary>Internetwork email routing facility.</summary>
+## <summary>Policy for sendmail.</summary>
 
 ########################################
 ## <summary>
@@ -18,7 +18,8 @@ interface(`sendmail_stub',`
 
 ########################################
 ## <summary>
-##	Read and write sendmail unnamed pipes.
+##	Allow attempts to read and write to
+##	sendmail unnamed pipes.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -36,7 +37,7 @@ interface(`sendmail_rw_pipes',`
 
 ########################################
 ## <summary>
-##	Execute a domain transition to run sendmail.
+##	Domain transition to sendmail.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -49,19 +50,30 @@ interface(`sendmail_domtrans',`
 		type sendmail_t;
 	')
 
-	corecmd_search_bin($1)
 	mta_sendmail_domtrans($1, sendmail_t)
+')
+
+#######################################
+## <summary>
+##  Execute sendmail in the sendmail domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`sendmail_initrc_domtrans',`
+	gen_require(`
+		type sendmail_initrc_exec_t;
+	')
 
-	allow sendmail_t $1:fd use;
-	allow sendmail_t $1:fifo_file rw_fifo_file_perms;
-	allow sendmail_t $1:process sigchld;
+	init_labeled_script_domtrans($1, sendmail_initrc_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute the sendmail program in the
-##	sendmail domain, and allow the
-##	specified role the sendmail domain.
+##	Execute the sendmail program in the sendmail domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -70,7 +82,7 @@ interface(`sendmail_domtrans',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the sendmail domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -81,7 +93,7 @@ interface(`sendmail_run',`
 	')
 
 	sendmail_domtrans($1)
-	roleattribute $2 sendmail_roles;
+    roleattribute $2 sendmail_roles;
 ')
 
 ########################################
@@ -102,6 +114,34 @@ interface(`sendmail_signal',`
 	allow $1 sendmail_t:process signal;
 ')
 
+#######################################
+## <summary>
+##  Execute sendmail in the unconfined
+##  sendmail domain, and allow the
+##  specified role the unconfined
+##  sendmail domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  Role allowed access.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`sendmail_run_unconfined',`
+    gen_require(`
+        attribute_role sendmail_unconfined_roles;
+    ')
+
+    sendmail_domtrans_unconfined($1)
+    roleattribute $2 sendmail_unconfined_roles;
+')
+
 ########################################
 ## <summary>
 ##	Read and write sendmail TCP sockets.
@@ -141,8 +181,7 @@ interface(`sendmail_dontaudit_rw_tcp_soc
 
 ########################################
 ## <summary>
-##	Read and write sendmail unix
-##	domain stream sockets.
+##	Read and write sendmail unix_stream_sockets.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -179,7 +218,7 @@ interface(`sendmail_dontaudit_rw_unix_st
 
 ########################################
 ## <summary>
-##	Read sendmail log files.
+##	Read sendmail logs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -199,8 +238,7 @@ interface(`sendmail_read_log',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	sendmail log files.
+##	Create, read, write, and delete sendmail logs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -220,8 +258,7 @@ interface(`sendmail_manage_log',`
 
 ########################################
 ## <summary>
-##	Create specified objects in generic
-##	log directories sendmail log file type.
+##	Create sendmail logs with the correct type.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -265,8 +302,7 @@ interface(`sendmail_log_filetrans_sendma
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	sendmail tmp files.
+##	Manage sendmail tmp files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -285,58 +321,27 @@ interface(`sendmail_manage_tmp_files',`
 
 ########################################
 ## <summary>
-##	Execute sendmail in the unconfined sendmail domain.
+##	Set the attributes of sendmail pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-#
-interface(`sendmail_domtrans_unconfined',`
-	gen_require(`
-		type unconfined_sendmail_t;
-	')
-
-	mta_sendmail_domtrans($1, unconfined_sendmail_t)
-
-	allow unconfined_sendmail_t $1:fd use;
-	allow unconfined_sendmail_t $1:fifo_file rw_fifo_file_perms;
-	allow unconfined_sendmail_t $1:process sigchld;
-')
-
-########################################
-## <summary>
-##	Execute sendmail in the unconfined
-##	sendmail domain, and allow the
-##	specified role the unconfined
-##	sendmail domain.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`sendmail_run_unconfined',`
+interface(`sendmail_setattr_pid_files',`
 	gen_require(`
-		attribute_role sendmail_unconfined_roles;
+		type sendmail_var_run_t;
 	')
 
-	sendmail_domtrans_unconfined($1)
-	roleattribute $2 sendmail_unconfined_roles;
+	allow $1 sendmail_var_run_t:file setattr_file_perms;
+	files_search_pids($1)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an sendmail environment.
+##	All of the rules required to administrate
+##	an sendmail environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -355,12 +360,17 @@ interface(`sendmail_admin',`
 		type sendmail_t, sendmail_initrc_exec_t, sendmail_log_t;
 		type sendmail_tmp_t, sendmail_var_run_t, unconfined_sendmail_t;
 		type sendmail_keytab_t;
+		type mail_spool_t;
 	')
 
-	allow $1 { unconfined_sendmail_t sendmail_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { unconfined_sendmail_t sendmail_t })
+	allow $1 sendmail_t:process signal_perms;
+	ps_process_pattern($1, sendmail_t)
 
-	init_labeled_script_domtrans($1, sendmail_initrc_exec_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 sendmail_t:process ptrace;
+	')
+
+	sendmail_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 sendmail_initrc_exec_t system_r;
 
@@ -376,6 +386,6 @@ interface(`sendmail_admin',`
 	files_list_pids($1)
 	admin_pattern($1, sendmail_var_run_t)
 
-	sendmail_run($1, $2)
-	sendmail_run_unconfined($1, $2)
+	files_list_spool($1)
+	admin_pattern($1, mail_spool_t)
 ')
